/* yasep/ISM/presentation.js
created 2007-03-28 by yann guidon
2007-11-05 : rebranding to YASEP
2009-07-09 : chaged before_load to addLoadEvent
2009-08-09
2009-08-23
*/

prfx='../';

/* inclusion of yasep/ISM/dump_opcode_table.js
created 2007-03-28 by yann guidon
2007-04-01 : added the IR notice
2007-04-08
2007-04-16
2007-04-17 : allowing aliases
2007-11-05 : rebranding to YASEP
2007-11-07 : some healthy updates
2007-12-25 : changed the condition to display the link to test_eu.html
2007-11-?? : added support for FLAG_OPTIONAL|YASEP32_ONLY|YASEP16_ONLY
2007-11-30 : test_eu turned into test_eu16 and test_eu32
2008-12-27 : included in yasep/ISM/presentation.js as after_load to make it work under Opera
2009-01-08 : changed after_load to before_load
*/

window.onload = function(){
  var x=document.getElementById('doc');
  var y=document.getElementById('example');
  var z=document.getElementById('dump');
  var op=document.title;
  op=op.toUpperCase();

  var s='<font color="red">internal error or wrong opcode name ?</font>';
  var u='';
  var m='';

  if (Y.table_opcode[op] != undefined) {
  /* display the properties */
    var o=Y.table_opcode[op];
        t=o.value,
        e=t & Y.FIELD_GROUP,
        f=o.forms,
        g=o.flags;

    s='            opcode : '+op+'\n'+
      '     opcode number : '+int2hex(t)+'\n';

    if (Y.GroupNames[e])
   s+='             group : '+Y.GroupNames[e].replace(/GROUP_/,'')+'\n';

    if (e == Y.GROUP_MUL)
      m+='<p><b>*</b> Look at <a href="../docs/multiply.html">multiply.html</a> for more informations on how to use this instruction.';

    if (g & Y.IMM16_5LSB)
      m+='<p><b>*</b> When using the "long immediate" form (<a href="../docs/instructions.html#IRR">IRR<a>), only the 5 least significant bits are used with YASEP32, and 4 bits with YASEP16.'
        +'<p><b>*</b> When using the "short immediate" form (<a href="../docs/instructions.html#iR">iR</a>), only 4 bits are available, be careful with YASEP32 (use the long form if more than 15 positions are needed)';

    if (g & Y.IMM16_8LSB)
      m+='<p><b>*</b> When using the "long immediate" form (<a href="../docs/instructions.html#IRR">IRR</a>), only the 8 least significant bits are used.';

    if (e==Y.GROUP_ROP2)
      m+='<p><table border="1">'
        +'<tr><td>si1</td><td>snd</td><td></td><td><a href="AND.html">AND</a></td><td><a href="ANDN.html">ANDN</a></td>'
        +'<td><a href="ANDN.html">NAND</a></td><td><a href="OR.html">OR</a></td><td><a href="ORN.html">ORN</a></td><td>'
        +'<a href="NOR.html">NOR</a></td><td><a href="XOR.html">XOR</a></td><td><a href="XORN.html">XORN</a></td></tr>'
        +'<tr><td>0</td><td>0</td><td></td><td>0</td><td>0</td><td>1</td><td>0</td><td>1</td><td>1</td><td>0</td><td>1</td></tr>'
        +'<tr><td>0</td><td>1</td><td></td><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td><td>0</td></tr>'
        +'<tr><td>1</td><td>0</td><td></td><td>0</td><td>1</td><td>1</td><td>1</td><td>1</td><td>0</td><td>1</td><td>0</td></tr>'
        +'<tr><td>1</td><td>1</td><td></td><td>1</td><td>0</td><td>0</td><td>1</td><td>1</td><td>0</td><td>0</td><td>1</td></tr>'
        +'</table></p>';

//flags : OPTIONAL|YASEP32_ONLY|YASEP16_ONLY
    if (g & Y.OPTIONAL)
      m+='<p><b>*</b> This instruction is <a href="../docs/flags.html#OPTIONAL">optional</a>'
       + ' and could be invalid, depending on the target core\'s implementation.</p>';

    if (g & Y.YASEP32_ONLY)
      m+='<p><b>*</b> This instruction is specific to <a href="../docs/flags.html#YASEP32_ONLY">YASEP32</a>'
       +' and has no meaning with a 16-bit version.</p>';

    if (g & Y.YASEP16_ONLY)
      m+='<p><b>*</b> This instruction is specific to <a href="../docs/flags.html#YASEP16_ONLY">YASEP16</a>'
       +' and has no meaning with a 32-bit version.</p>';

    if ((typeof(Y.opcode_table[t].action32) == "function")
    ||  (typeof(Y.opcode_table[t].action16) == "function")) {
      m+= '<p><b>*</b> You can play with this instruction with ';
      if (((typeof(Y.opcode_table[t].action32) == "function") && (typeof(Y.opcode_table[t].action16) == "function")))
        m+= '<a href="'+prfx+'benches/test_eu16.html">test_eu16.html</a> and '
           +'<a href="'+prfx+'benches/test_eu32.html">test_eu32.html</a>.</p>\n';
      else {
        if (typeof(Y.opcode_table[t].action16) == "function")
          m+= '<a href="'+prfx+'benches/test_eu16.html">test_eu16.html</a>.</p>\n';
        else
          m+= '<a href="'+prfx+'benches/test_eu32.html">test_eu32.html</a>.</p>\n';        
      }
    }

    if (o.description)
   s+='       Description : '+o.description+'\n';
 
   s+='             Forms : '+Y.form2html(f)+'\n';

/* generate the examples */
    var i,j,k,l,fill='                ';
    for (i in Y.TableForm) {
      if (f & i) {
        j=Y.TableForm[i];
        k=j.replace(/FORM_/,'');

        l=Y.TableFormFunction[i](g);
        if (l!='')
          l=op+" "+l;
        else
          l=op;

        u+=' - <a href="'+prfx+'docs/instructions.html#'+k+'">'+j+'</a>'
          +fill.slice(j.length)+'<a class="asm">'+l+'</a>\n';
        if ((i & Y.FORMS_EXTENDABLE)&&((g & Y.NO_CONDITION)==0))
          u+='   With condition  <a class="asm">'+l+' '+Y.randomCondition()+'</a>\n';
      }
    }

  /* the flags */
    if (g > 0) {
   s+='             Flags :'
      for (i in Y.TableFlags) {
        if (g & i) {
          s+=' <a href="'+prfx+'docs/flags.html#'
              +Y.TableFlags[i].replace(/FLAG_/,'')+'">'
              +Y.TableFlags[i]+'</a>';
        }
      }
   s+='\n';
    }
  } // table_opcode[op]!=undefined

  x.innerHTML=m;
  y.innerHTML=u;
  z.innerHTML=s;
}; // was : before_load


document.write(
'<p id="doc"></p>'+
'<h3>Syntax examples :</h3>\n'+
'<pre id="example" class="instr">\n'+
'</pre>\n'+
'<h3>JavaScript properties of this opcode :</h3>\n'+
'<pre id="dump">\n'+
'</pre>\n'+
'<link href="../yasep.css" rel="stylesheet" type="text/css">\n'+
'<script type="text/javascript" src="'+prfx+'JSgui/js_list2.js"></script>\n');
