/*
  yasep/JSgui/floating_asm.js
  used by : (most) HTML documents

 - This file is included at the END of a HTML document
 - it creates a <div> that is shown/hidden/moveable
 - it embeds asm.html inline...
 - requires no modification to the HTML because it works at the DOM level,
     it hooks the <a> tags and modifies those with the correct href
 - intercepts mouse clicks on <a href=""> to redirect the asm to the <div>
 - when given inline_asm=="asm.html", it melts into the existing page

2007-03-28 : changed the calling convention :
the page must set the variable "prfx" to its own depth in the directory tree
2007-04-08 : added call to after_load() 
   removed 2009-07-09 in favor of addLoadEvent()
2007-04-11 : calling page must load JSgui/js_list.js
2007-11-05 : rebranding to YASEP
2008-11-30 : correction for Opera : ev.layerX/Y does not work, using relative .pageX/Y instead.
2009-01-08 : added before_load
2009-01-18 : enhancements to the inline assembly/disassembly
2009-01-23 : references to asm.html : path update
2009-07-09 : big changes, adding ygwm !
2009-07-28 : asm objectification
2009-08-10 : new disassembler
20090830 : new code strategy, more DOM-oriented
*/

var asm_win, size_id,asm=null,
asm_interface_string=
'<table id="div_asm" border="0" cellspacing="2" cellpadding="2">'+
'<tr cellpadding="4">'+
' <td align="right">'+
'  asm&nbsp;form&nbsp;:'+
' </td>'+
' <td width="0" colspan="2">'+
'  <form name="asm_form" action="javascript:update_asm();">'+
'   <input type="text" size="30" maxlength="80" name="value_asm" value="add 123 r1 r2">'+
'  </form>'+
' </td>'+
' <td>'+
'  <input type="submit" onclick="update_asm()" value=" assemble ">'+
' </td>'+
'</tr>'+
'<tr cellspacing="4">'+
' <td align="right">'+
'  hex&nbsp;value&nbsp;:'+
' </td>'+
' <td width="0">'+
'  <form name="hex_form" action="javascript:update_hex();">'+
'   <input type="text" size="12" maxlength="12" name="value_hex">'+
'  </form>'+
' </td>'+
' <td>'+
'  <span id="size_id"></span>'+
' </td>'+
' <td>'+
'  <input type="submit" value="disassemble" onclick="update_hex()">'+
' </td>'+
'</tr>'+
'<tr cellpadding="3" cellspacing="5"><td colspan="4">'+
' <div id="messages" padding="3">'+
'  <font color="red"><b>'+
'   This browser sucks, system not yet initialised, internal error or Javascript not activated/supported ?'+
'  If this message does not disappear, check your JavaScript console/error messages.'+
'  </b></font>'+
' </div>'+
'</td></tr>'+
'</table>';

function update_asm(){
  if (asm===null)
    asm=new Yasep_ASM();
  if (asm.encode_YASEP_instruction(document.asm_form.value_asm.value)) {
    document.hex_form.value_hex.value=int2hex(asm.encoded_instruction,2*asm.encoded_size_bytes-1,2*asm.encoded_size_bytes-1);
    size_id.innerHTML="size : "+asm.encoded_size_bytes+" bytes";
  }
  else {
    document.hex_form.value_hex.value="";
    size_id.innerHTML="";
  }
}

function update_hex(){
  if(typeof D!="object")
    D=new Yasep_DISASM();
  D.decode_instruction(str2int(document.hex_form.value_hex.value));
  if (D.form!=null) {
    document.asm_form.value_asm.value=D.instruction;
    size_id.innerHTML="size : "+D.size_bytes+" bytes";
  }
  else {
    document.asm_form.value_asm.value="error";
    size_id.innerHTML="";
  }
}

function trigger_asm(loc){
  if (loc!='') {
    var i=loc.indexOf('?');
    if (i==2){
      var a=loc.slice(3);
      loc=loc.slice(0,2);
      if (loc=="#a") {
        if (a) {
          document.asm_form.value_asm.value=unescape(a);
          update_asm();
        }
      }
      else
        if (loc=="#d") {
          if (a) {
            document.hex_form.value_hex.value=unescape(a);
            update_hex();
          }
        }
    }
  }
}


function attach_tags_asm(){
  // Scan all the <a> tags and attach an onclick event.
  var u=document.getElementsByTagName('a');
  for (var i in u){
    var t=new String(u[i].innerHTML);
    // remove unbreakable spaces
    t=t.replace(/[&][Nn][Bb][Ss][Pp][;]/g,' ');
    // assembly
    if (u[i].className=="asm") {
      u[i].href=prfx+"tools/asm.html#a?"+t;
      u[i].onclick=getxy_asm;
    }
    // disassembly
    if (u[i].className=="disasm") {
      u[i].href=prfx+"tools/asm.html#d?"+t;
      u[i].onclick=getxy_asm;
    }
  }
}

function getxy_asm(ev){
  var asm_div_top = ev.pageY+30;
  var asm_div_left=ev.pageX-100;
  if (asm_div_left<3)
    asm_div_left=3;
  asm_win.move(asm_div_left, asm_div_top);
  asm_win.show_all();

// Fill the input fields with the contents of the URL
  var t=new String(this.href);
  t=t.replace(/^.*[#]/,'');
  t=t.replace(/[%]20/g,' ');
  trigger_asm('#'+t);
  document.hex_form.value_hex.focus(); // scrolls automatically if the div is below the window's border
  return false;
}

function init_asm_floating() {
  var wid=document.createElement("DIV");
  wid.innerHTML=asm_interface_string;
  asm_win=ygwm.new_window("Floating asm window",null,wid,
    500,140,20,20,false,true,true,false,true);
// new options :
//    hide/show instead of close : ok (added a creation parameter)
//    move inside the page ==> .move()
//    invisible by default ?  ==> .hide_all() :
  asm_win.hide_all();
  asm_win.reframe=true; // keep the thing inside the visible window

  messages=document.getElementById('messages');
  size_id=document.getElementById('size_id');
  document.getElementById('div_asm').style.width="100%";
//  var t=document.getElementById('div_asm');
//  t.style.width="100%";

  attach_tags_asm();
  add_message('blue', '<b>YASEP</b> JavaScript Assembler version '+version_date);
}

function init_asm_inline() {
  messages=document.getElementById('messages');
  size_id=document.getElementById('size_id');
  add_message('blue', '<b>yasep/tools/asm.html</b> version '+version_date);
  var init=document.location.hash;
  if (init!='') {
    init=init.split(/[?]/,3);
    if ((init[0]=="#a")||(init[0]=="#d"))
      trigger_asm(document.location.hash);
  }
}

if (typeof __disable_asm_float=="boolean") {
  document.write(asm_interface_string);
  addLoadEvent(init_asm_inline);
}
else {
  if (typeof(ygwm) != "undefined")
    addLoadEvent(init_asm_floating);
}
