-- speed_IE.vhd
-- Version 20090102 by whygee@f-cpu.org
-- version 20090813 : new port names

library IEEE;
use ieee.std_logic_1164.all;

entity speed_IE is
  generic (
    YASEP_SIZE : integer := 16 -- either 16 or 32
  );
  port(
    SND, SI4 : in std_logic_vector(YASEP_SIZE-1 downto 0);
    Clk, Load, SignExt, OffsetA : in std_logic;

    ResultIE : out std_logic_vector(YASEP_SIZE-1 downto 0)
  );
end speed_IE;

architecture speed of speed_IE is
  signal SNDr, SI4r : std_logic_vector(YASEP_SIZE-1 downto 0);
  signal Loadr, SignExtr, OffsetAr : std_logic;
  signal ResultIEr : std_logic_vector(YASEP_SIZE-1 downto 0);
begin

  IE:
    entity work.IE_16(second)
    generic map(
      YASEP_SIZE => YASEP_SIZE
    )
    port map(
      SND      => SNDr,
      SI4      => SI4r,
      Load     => Loadr,
      SignExt  => SignExtr,
      OffsetA  => OffsetAr,

      ResultIE => ResultIEr
    );

  process(Clk, SND, SI4, Load, SignExt, OffsetA, ResultIEr)
  begin
    if (clk'event and clk='1') then
      SNDr     <= SND;
      SI4r     <= SI4;
      Loadr    <= Load;
      SignExtr <= SignExt;
      OffsetAr <= OffsetA;

      ResultIE <= ResultIEr;
    end if;
  end process;

end speed;