-- speed_SHL16.vhd
-- version 20090101
-- 20090813 : std_ulogic, new port names
-- 2009-08-14 : back to std_logic

library ieee;
use ieee.std_logic_1164.all;

entity testdiff is
  generic (
    YASEP_SIZE : integer := 16;
    PIPELINED  : integer := 1   -- pipelined when 1
  );
  port(
    DataA : in std_logic_vector(YASEP_SIZE-1 downto 0);
    DataB : in std_logic_vector(3 downto 0);
    clk, SHL_en, Rotation, Direction, Arithmetic : in std_logic;

    diff : out std_logic_vector(YASEP_SIZE-1 downto 0));
end testdiff;

architecture toplevel of testdiff is
  signal inA, ResDUT : std_logic_vector(YASEP_SIZE-1 downto 0);
  signal inB : std_logic_vector(3 downto 0);
  signal SHL_enr, lRot, lDir, lArith : std_logic;
begin

speed:
  entity work.SHL_16(behaviour)
  generic map(
  	PIPELINED  => PIPELINED,
    YASEP_SIZE => YASEP_SIZE
  )
  port map(
    SND        => inA,
    SI4        => inB,
    clk        => clk,
    SHL_en     => SHL_enr,
    Rotation   => lRot,
    Direction  => lDir,
    Arithmetic => lArith,

    ResultSHL  => ResDUT
  );

  -- pipeline gates
  latche : process(clk, DataA, DataB,
     SHL_en, Rotation, Direction, Arithmetic)
  begin
    if (clk'event and clk='1') then
      inA     <= DataA;
      inB     <= DataB;
      SHL_enr <= SHL_en;
      lRot    <= Rotation;
      lDir    <= Direction;
      lArith  <= Arithmetic;

      -- output
      diff <= ResDUT;
    end if;
  end process;

end toplevel;

