/* arf/menu/menu.js
   version 20080815
 */

var menu_button_list=new Array();
var spacer=document.createTextNode(" ");
var add_message=function(color,msg) { alert(msg); };

/* adds a button to the menu bar 
 please indicate the name (no space), a function to call,
  and whether it is active upon creation.
*/
function new_menu_button(name, action, status) {
  menu_button_list[name]=new Object();
  menu_button_list[name].status=status;
  menu_button_list[name].action=action;

  var b=document.createElement("span");

  if (status)
    b.className="span_button_on";
  else
    b.className="span_button_off";

  b.id=name;
  b.innerHTML=name;
  b.onclick=function (ev) { menu_onclick_dispatch(ev.target.id) ; };

  menu_button_list[name].id=b;
  menu_div_id.appendChild(spacer);
  menu_div_id.appendChild(b);   
  menu_div_id.appendChild(spacer);
}

/* in case some app wants to unregister itself */
function menu_remove_button(name) {
  var m=menu_button_list[name];
  if (typeof(m)=='object') {
    menu_div_id.removeChild(m.id);
  }
}


/* makes a button active */
function menu_button_enable(name) {
  if(typeof(menu_button_list[name])!='object') {
    add_message("red", "BUG : button "+name+" does not exist");
    return;
  }
  if(menu_button_list[name].status!=false) {
    add_message("red", "BUG : button "+name+" is already enabled");
    return;
  }
  menu_button_list[name].status=true;
  menu_button_list[name].id.className="span_button_on";
}

/* makes the button silent */
function menu_button_disable(name) {
  if(typeof(menu_button_list[name])!='object') {
    add_message("red", "BUG : button "+name+" does not exist");
    return;
  }
  if(menu_button_list[name].status!=true) {
    add_message("red", "BUG : button "+name+" is already disabled");
    return;
  }
  menu_button_list[name].status=false;
  menu_button_list[name].id.className="span_button_off";
}


/* this is called when a button is pressed.
The argument is the name of the pressed button */
function menu_onclick_dispatch(n) {

  // if mouse etc. + abortion here here

  var m=menu_button_list[n];
  if (m.status != true)
    return;
  var f=m.action;
  if (typeof(f)=="function")
    f();
}


/* where the action happens */

function menu_load() {
//  menu_remove_button('load');

//menu_button_enable("save"); 
//menu_button_disable("load");
}

function menu_save() {
//menu_button_disable("save"); 
//menu_button_enable("load");
}

function menu_undo() {


}

function menu_redo() {


}

function menu_new() {


}

function menu_setting() {


}

function menu_help() {


}

function menu_flash() {
  add_message("green","flash !");
}

/* init */
function init_menu() {
  menu_div_id=document.getElementById('menu');

  new_menu_button("new",  menu_new, false);
  new_menu_button("load", menu_load, false);
  new_menu_button("save", menu_save, false);
  new_menu_button("undo", menu_undo, false);
  new_menu_button("redo", menu_redo, false);
  new_menu_button("flash", menu_flash, false);
  new_menu_button("settings", menu_setting, false);
  new_menu_button("help", menu_help, false);

  window.parent.frame_loaded_menu_postinit=menu_postinit;
  window.parent.frame_loaded_menu=true;
}

function menu_postinit() {
  add_message=window.parent.add_message;
  menu_button_enable('flash');
}
