/* tools/listed.js
created 2009-01-23 by yg@yasep.org
2009-01-26
2009-01-31
2009-02-01
2009-02-06 : moved most code to the listed object
2009-02-10 : style changes, feedback from Stphane Moriaux etc.
Feb 12 01:07:16 2009 : style changes again
Feb 16 02:34:50 2009
todo : gestion des vnements avec seamonkey : souris qui dtecte pas le relchement du bouton
Feb 24 01:30:28 2009 : j'ai 32 ans ! et j'ai runi les 2 images de la poubelle en une [:kikiv]
2009-07-07 : moved to tools/
2009-07-11 : new argument to ygwm.new_window
2009-07-22 : column hiding
2009-07-27 : duplicate_listing_row fixed
*/

var listed={

// Node IDs :
template:null,
moved_row:null,
moved_row_prevSibling:null,
moved_row_prev_index:null,
moved_row_parent:null,
moved_row_original_parent:null,
moved_row_root:null,

dragdropstate : 0, // state of the drag&drop operation
  // 0 : nothing, 1: move a listing row, 2: move a symtable row
tr_moved:false,
OddEvenArray:new Array("even", "odd"),

////////////////////////////////////////////////////

getParent:function(where){
  // get back to the root of the div
  if (where==null)
    return null;
  while(!where.table_listing_id) {
    where=where.parentNode;
    if (where==null)
      return null;
  }
  return where;
},

////////////////////////////////////////////////////
// Short Messages :

shortmsg:function(where, msg) {
  where=ygwm.getParent(where);
  if (where.timeout_var)
    clearTimeout(where.timeout_var);
  where.shortmsg(msg);
  where.timeout_var=setTimeout(where.erase_msg, 2000);
  return false;
},

// called by mouseovers
caption:function(where, m) {
  if (null==document.onmousemove)
    listed.shortmsg(where,m);
  return false;
},

caption_hide:function() {
  listed.caption(this,"Click here to hide this column");
},

caption_none:function() {
  listed.caption(this,"");
},

////////////////////////////////////////////////////
// Trash image animation
//trash_image_cache:null,
trash_open:false,
trash_open_conditions:new Array,

trash_mouseover:function() {
  if ((listed.dragdropstate > 0) // drag&drop ?
   ||(ygwm.action_function==ygwm.mouse_drag)) { // interaction with ygwm
    listed.trash_image_id.style.right="48px";
    listed.trash_open=true;
  }
  return true;
},

// serves also as a callback for ygwm
trash_mouseout:function() {
  if (listed.trash_open) {
    listed.trash_image_id.style.right="0px";
    listed.trash_open=false;
    // detect that a window is being closed
    // cleanup of the moved window... getElement(,,) ?
    // cleanup the variables to avoid leaks
    return true;
  }
  return false;
},

//////////////////////////////////////////////////////
// cleanup a table, remove any #text node inbetween the TR TH and TDs
cleanup_table:function(tbody_id) {
  var id=tbody_id.firstChild, tr, td, td2;   /// !!!!
  // scan the tbody
  while (id != null) {
    // preload the next sibling because we might remove id
    tr=id.nextSibling;
    if (id.nodeName!="TR")
      tbody_id.removeChild(id);
    else {
      // recurse : scan the TD/TH
      td = id.firstChild;
      while (td != null) {
        td2=td.nextSibling;
        if ((td.nodeName!="TD")&&(td.nodeName!="TH"))
          id.removeChild(td);
        td=td2;
      }
    }
    id=tr;
  }
},


////////////////////////////////////////////////
// hide/show columns
// derived from Alexandre Morgaut's Usenet post
hideColumn: function () {
  // this is the column title which has been clicked
  this.colgrp.style.visibility="collapse";
  this.button.style.display="";
},

showColumn: function () {
  // this is the button which has been clicked
  this.colgrp.style.visibility="";
  this.style.display="none";
},


////////////////////////////////////////////////////
// Row (re)numbering and coloring

renumber_lines:function(id,n) {
  // first parameter : id of the first TR to modify
  // 2nd parm: its intended line number;
  var parent=id.parentNode;

  while (id != null) {
    if (id.TrLineNr) {
      // Abort if the list is in sync (spare CPU cycles)
      if (id.TrLineNr == n)
        return;
    }
    else // no line number : create it and the hooks (used during init or when new lines are added)
      parent.update_row_hooks(id,false);

    id.className=listed.OddEvenArray[n & 1]; // update the background color
    id.numero_id.nodeValue=n;  // create/update the numbers
    id.TrLineNr = n++;

    id=id.nextSibling; // go to the next element
  }

  // if the end of the list is reached,
  if (id == null)
    parent.nbElements=n; // update the element count.

  // callback to reassemble/recheck the array ?
},

/*************************************
 *           Drag & Drop             *
 *************************************/

// When the mouse goes over a TR :
capture_mouseover_TR:function(ev) {
  var parent=this.parentNode;
  
  if ((listed.dragdropstate > 0) && (this != listed.moved_row)
     // If we're moving a TR in the same type of table, it's our event :
    && (parent.update_row_hooks == listed.moved_row_parent.update_row_hooks)) {

    var newIndex=this;
    // move a row within the same table ?
    if (parent == listed.moved_row_parent) {
      // evaluate where it's better to put the row...
      if ((this.TrLineNr > listed.moved_row_prev_index)
      || ((this.TrLineNr == listed.moved_row_prev_index)
           &&(this.previousSibling==listed.moved_row)))
        newIndex=this.nextSibling;
    }
    // move from another table
    else {
      // focus
      ygwm.focus_window(null,ygwm.getParent(this));
    }
    listed.moved_row=listed.moved_row_parent.removeChild(listed.moved_row);
    listed.moved_row=parent.insertBefore(listed.moved_row,newIndex);
    listed.tr_moved=true; // force renumbering on onmouseup
    listed.moved_row_prev_index = this.TrLineNr;
    listed.moved_row_parent=parent;
    return false;
  }
  return true;
},

// onmouseup :
mouse_drop_row:function(ev) {
// local copy
  moved_row=listed.moved_row;
// if erased :
  if (listed.trash_open==true) { // trash_open is set whenever the erase conditions are satisfied.
    listed.moved_row_parent.removeChild(moved_row);
    // original point of view in original table :
    if (listed.moved_row_prevSibling.nextSibling) // Is it the last element of the table ?
      listed.renumber_lines(listed.moved_row_prevSibling.nextSibling, moved_row.TrLineNr);
    else
      listed.moved_row_original_parent.nbElements--; // update the element count.
    //  update the cached values and tables, and call a callback in the parent ?
    listed.shortmsg(listed.moved_row_root,"yum yum !");    
    listed.trash_mouseout();
  }

  else {
    if ((listed.tr_moved==false) // If nothing has really moved
        || (moved_row.previousSibling == listed.moved_row_prevSibling)) {
      // restore the style
      moved_row.className=listed.OddEvenArray[moved_row.TrLineNr & 1];
    }
    // MOVED ROW ? then reorder them
    else {
      listed.tr_moved=false;
      if (listed.moved_row_prevSibling.nextSibling) // Is it the last element of the table ?
        listed.renumber_lines(listed.moved_row_prevSibling.nextSibling, moved_row.TrLineNr);
      else
        listed.moved_row_original_parent.nbElements--; // only update the element count.

      moved_row.TrLineNr=-2; // force the restoration of the style in some cases.
      var t=moved_row.previousSibling.TrLineNr; // first row ?
      if(typeof t=="number") 
        t++;
      else
        t=0;
      listed.renumber_lines(moved_row,t);
    }
  }

  listed.dragdropstate = 0;
  document.onmouseup=null;
  document.onmousemove=null;
  document.body.style.cursor='auto';
  return false;
},

/// onmousedown :
start_move_row:function(ev) {
// anti-window-manager-hickup :
  if (document.onmouseup!=null)
    document.onmouseup(ev);

  // get the selected TR's id
  // listed.getParent(this); ??
  var moved_row=this;
  while (moved_row.nodeName != "TR") {
    moved_row=moved_row.parentNode;
    if (moved_row==null)
      return false;
  }
  listed.moved_row = moved_row; // local copies
  var moved_row_parent=moved_row.parentNode;
  listed.moved_row_parent=moved_row_parent;
  listed.moved_row_original_parent=moved_row_parent;
  listed.moved_row_root=listed.getParent(moved_row_parent);
  listed.moved_row_prev_index=moved_row.TrLineNr;

  // Drag&Drop
  if ((moved_row_parent.update_row_hooks == listed.update_symtable_row_hooks)
  ||  (moved_row_parent.nbElements > 1)) {
    // There's no point in moving or erasing the last line of the listing
    // (or else we won't be able to recreate the others)
    listed.moved_row_prevSibling=moved_row.previousSibling;  // there is ALWAYS a previous sibling (the header or colgroups)
    moved_row.className="selected";  // highlight / change the display style

    // move action
    listed.dragdropstate = 1; // default, listing
    if (moved_row_parent.update_row_hooks == listed.update_symtable_row_hooks) {
      listed.dragdropstate = 2;
    }
    document.onmouseup=listed.mouse_drop_row;
    document.onmousemove=ygwm.autoScroll;
    document.body.style.cursor='move';
  }
  return false;
},


/*************************************
 *           Symbol table            *
 *************************************/

////////////////////////////////////////////////////
// captions
caption_symtable_plus : function(){
  listed.caption(this,'Click to add a blank symbol line.');
  return false;
},

/*
listed.caption_symtable_value=function() {
  listed.caption(this,"Click here to change the value of the symbol.");
}
listed.caption_symtable_name=function() {
  listed.caption(this,"Click here to change the name of the symbol.");
}
listed.caption_symtable_comm=function() {
  listed.caption(this,"Click here to change the comment.");
} */
caption_symtable_numero:function() {
  listed.caption(this,"Drag and drop the line to another line or to the trash bin."
     +" CTRL+click to duplicate the line.");
  return false;
},

// init == true => erase the previous contents of the TR
//  otherwise, preserve the contents
update_symtable_row_hooks:function(id, init) {
  // Build the TR ID cache, hook the callbacks, clear the contents
  id.onmouseover=listed.capture_mouseover_TR;
  var u=id.firstChild;
  while (u!=null){
    var v=u.firstChild;
    if (init==true)
      v.nodeValue="";
    switch(u.className) {
      case "numero"  :
        id.numero_id=v;
        u.onmousedown=listed.start_move_row;
        u.onmouseover=listed.caption_symtable_numero;
        u.onmouseout=listed.caption_none;
        break;
//    case "symval"  :  u.onmouseover=listed.caption_symtable_value;  break;
//    case "symname" :  u.onmouseover=listed.caption_symtable_name;   break;
//    case "symtype" :     break;
      case "symcomm" : // u.onmouseover=listed.caption_symtable_comm;
        id.symcomm_id=u;
        if (init==true)
          v.nodeValue=listed.dumb_counter2++;
        break;
//    case "symdef"  :        break;
//    case "symused" :        break;
    }
    u=u.nextSibling;
  }
},

////////////////////////////////////////////////////

dumb_counter2:0,

symtable_value_plus:function(ev) {
// anti-window-manager-hickup :
  if (document.onmouseup!=null)  
    document.onmouseup(ev);

  // where are we ?
  where=listed.getParent(this);

  // clone the spare row
  var new_symrow = where.blank_symtable_row.cloneNode(true);
  listed.update_symtable_row_hooks(new_symrow,true);
  // append and display the new row
  var t = where.table_symbols_id.insertBefore(new_symrow, where.symtable_tr_header_id.nextSibling);
  // side effect : insertBefore behaves like appendChild when the 2nd operand is null

  listed.renumber_lines(t, 0);
  return false;
},

/* not yet done
listed.symtable_value_sort_down() {
  listed.shortmsg(this,"symtable_value_sort_down");
}
listed.symtable_value_sort_up() {
  listed.shortmsg(this,"symtable_value_sort_up");
}
listed.symtable_name_sort_down() {
  listed.shortmsg(this,"symtable_name_sort_down");
}
listed.symtable_name_sort_up() {
  listed.shortmsg(this,"symtable_name_sort_up");
}
listed.symtable_def_sort_up() {
  listed.shortmsg(this,"symtable_def_sort_up");
}
listed.symtable_def_sort_down=function() {
  listed.shortmsg(this,"symtable_def_sort_down");
}
*/

/*************************************
 *            Listing                *
 *************************************/

dumbcounter:0,

////////////////////////////////////////////////////

duplicate_listing_row:function(ev) {
// anti-window-manager-hickup :
  if (document.onmouseup!=null)
    document.onmouseup(ev);

  // this is the id of the <td class="plus">
  var originalTR = this.parentNode;
  var newTR;

  // new row
  newTR = originalTR.cloneNode(true);

  // erase properties or duplicate ?
  listed.update_listing_row_hooks(newTR,!ev.ctrlKey);

  // include the new row in the table (which forces reflow and redraw)
  originalTR.parentNode.insertBefore(newTR,originalTR.nextSibling);
  listed.renumber_lines(newTR, originalTR.TrLineNr+1);
  return false;
},

////////////////////////////////////////////////////

// Button and zones helper bubbles
caption_listing_plus:function() {
  listed.caption(this,"Click to add a new blank line, CTRL+click to duplicate the line.");
},
caption_listing_line:function() {
  listed.caption(this,"Drag&drop the line to the trash bin or to another line.");
},

// caption_listing_value:function() { listed.caption(this,"Click to edit the value and trigger disassembly."); },
// caption_listing_label:function() { listed.caption(this,"Click to add/edit a label."); },
// caption_listing_instr:function() { listed.caption(this,"Click to edit the instruction that will be assembled."); },
// caption_listing_comment:function(){listed.caption(this,"Click to edit the line's comment."); },

// erase the TR's contents if init==true
update_listing_row_hooks:function(id,init) {
  id.onmouseover=listed.capture_mouseover_TR;
  var u=id.firstChild;
  while (u!=null) {
    var v=u.firstChild;
    if ((v) && (init==true))
      v.nodeValue="";
    switch(u.className) {
      case "plus" :
        u.onclick=listed.duplicate_listing_row;
        u.onmouseover=listed.caption_listing_plus;
        u.onmouseout=listed.caption_none;
        break;
      case "numero" :
        id.numero_id=v;
        u.onmousedown=listed.start_move_row;
        u.onmouseover=listed.caption_listing_line;
        u.onmouseout=listed.caption_none;
        break;
/*    case "address" :
        break;
      case "size" :
        break;
      case "value" :        u.onmouseover=listed.caption_listing_value;
        break;
      case "label" :  u.onmouseover=listed.caption_listing_label;   break;
        break;
      case "instr" : u.onmouseover=listed.caption_listing_instr;   break;
        break; */
      case "comment" : //u.onmouseover=listed.caption_listing_comment;
        if (init==true)
          v.nodeValue=listed.dumbcounter++;
        break;
    }
    u=u.nextSibling;
  }
},

hook_hidecol: function(div_id){
  var a,b,i,j,r=new Array(), s=new Array();
  var m="";

  // find all the buttons
  a=div_id.getElementsByTagName("BUTTON");
  for (i in a)
    if (a[i].id)
      r[a[i].id]=a[i];

  // find all the colgroups
  b=div_id.getElementsByTagName("COLGROUP");
  for (i in b)
    if (b[i].id)
      s[b[i].id]=b[i];

  // hook the listing table :
  var u=div_id.table_listing_id.firstChild.firstChild;
  while (u!=null){
    m+=u.className+' ';
    switch(u.className) {
      case "address" :
      case "size" :
      case "value" :
      case "comment" :
      case "depends" :
      case "latency" :
        i="btl_"+u.className;
        j="lst_"+u.className;
        if(r[i] && s[j]){
          u.button=r[i];
          u.colgrp=s[j];
          r[i].colgrp=s[j];
          r[i].style.display="none";
          r[i].onclick=listed.showColumn;
             u.onclick=listed.hideColumn;
          r[i].onclick();
          u.onmouseover=listed.caption_hide;
          u.onmouseout=listed.caption_none;
          u.style.cursor="pointer";
        }
    }
    u=u.nextSibling;
  }

  // hook the symbol table :
  var u=div_id.table_symbols_id.firstChild.firstChild;
  while (u!=null){
    m+=u.className+' ';
    switch(u.className) {
      case "symtype" :
      case "symval" :
      case "symcomm" :
      case "symdef" :
      case "symused" :
        i="bts_"+u.className;
        j="sym_"+u.className;
        if(r[i] && s[j]){
          u.button=r[i];
          u.colgrp=s[j];
          r[i].colgrp=s[j];
          r[i].style.display="none";
          r[i].onclick=listed.showColumn;
             u.onclick=listed.hideColumn;
          r[i].onclick();
          u.onmouseover=listed.caption_hide;
          u.onmouseout=listed.caption_none;
          u.style.cursor="pointer";
        }
    }
    u=u.nextSibling;
  }
},

/*************************************
 *              General              *
 *************************************/

new_listed:function(parent,name) {
  var div_id=listed.template.cloneNode(true);
  // makes the div visible
  div_id.id=name;
  // attach to the DOM tree AFTER modifying its properties...
  parent.appendChild(div_id);

  // update the listing name :
  div_id.name_id=getByClass("block_name","SPAN",div_id);
  div_id.name_id.innerHTML=name;

  // locate the table bases
  div_id.table_listing_id = getByClass("table_listing","TBODY",div_id);
  div_id.table_listing_id.update_row_hooks = listed.update_listing_row_hooks;
  div_id.table_symbols_id = getByClass("table_symbols","TBODY",div_id);
  div_id.table_symbols_id.update_row_hooks = listed.update_symtable_row_hooks;

  // update the listing :
  listed.hook_hidecol(div_id);
  listed.renumber_lines(div_id.table_listing_id.firstChild.nextSibling, 0);

  // update the symtable :
  div_id.symtable_tr_header_id=div_id.table_symbols_id.firstChild;
  var u=div_id.symtable_tr_header_id;
  var v=getByClass("click_plus","IMG",u);
  v.onclick=listed.symtable_value_plus;
  v.onmouseover=listed.caption_symtable_plus;
  u=u.nextSibling;
  div_id.blank_symtable_row = u.cloneNode(true);
  listed.renumber_lines(u, 0);

  return div_id;
},

editorcount:1,
editorprefix:"function_",
addListed:function(ev,x,y){
  var z=false;
  // generate a new name
  var n=listed.editorprefix+listed.editorcount++;
  // create a new window
  if (!x) {
    var p=mousePos(ev);
    z=true;
    x=p.x - 4; // mouse coordinates when a new
    y=p.y - 4; // window is created by clicking a button
  }
  var win=ygwm.new_window(n,this,"none",600, 400, x, y,
     listed.trash_mouseout, true, true, false, false);

  // generate a new listing
  var id=listed.new_listed(win.contents_id,n);

  if (z) // force a drag&drop sequence if we clicked on a specific button
    win.header_id.onmousedown(ev);
}

}; // end of listed object

////////////////////////////////////////////////////////////////////////////////////

// put the first windows and the global callbacks in place
function init_listed() {
  // Install the trash image callbacks
  listed.trash_image_id=getById("trash_image","IMG");
  listed.trash_image_id.style.zIndex=ygwm.noScrollIndex;
  listed.trash_image_id.onmouseover=listed.trash_mouseover;
  listed.trash_image_id.onmouseout= listed.trash_mouseout;

  // get and cleanup the hidden copy of the template div
  listed.template=document.getElementById("listed_template");
  listed.cleanup_table(getByClass("table_listing","TBODY",listed.template));
  listed.cleanup_table(getByClass("table_symbols","TBODY",listed.template));

  // Put the documentation in a removable window
  ygwm.new_window("Explications", document.getElementById('fineprints'), null,
    500, 400, 20, 40, listed.trash_mouseout, true, true, false, false);

  // "add new editor" button
  var adl=getById("addListed","BUTTON");
  adl.style.zIndex=ygwm.noScrollIndex;
  adl.onmousedown=listed.addListed;
  adl.onmousedown(null,220,110);
  // force the creation of a first listed that will be put at a default window location)

  // remove the speculative error message.
  adl.parentNode.removeChild(document.getElementById("deleteme"));
}

addLoadEvent(init_listed);

/* Todo :
  <th class="symval">
    &nbsp;Value&nbsp;<!--
    <img src="sort_down.png" class="click" on onclick="listed.symtable_value_sort_down();"
         onmouseover="listed.caption(this,'Sort by symbol values (highest first)');">&nbsp;
    <img src="sort_up.png"   class="click" onclick="listed.symtable_value_sort_up();"
         onmouseover="listed.caption(this,'Sort by symbol values (lowest first)');">-->
  </th>
  <th class="symname">&nbsp;Name&nbsp;<!--
    <img src="sort_down.png" class="click" onclick="listed.symtable_name_sort_down();"
         onmouseover="listed.caption(this,'Sort by name');">&nbsp;
    <img src="sort_up.png"   class="click" onclick="listed.symtable_name_sort_up();"
         onmouseover="listed.caption(this,'Sort by name');">-->
  </th>
  <th class="symtype">&nbsp;Type&nbsp;<!--
    <img src="sort_down.png" class="click" onclick="listed.symtable_type_sort_down();"
         onmouseover="listed.caption(this,'Sort by type');">&nbsp;
    <img src="sort_up.png"   class="click" onclick="listed.symtable_type_sort_up();"
         onmouseover="listed.caption(this,'Sort by type');">-->
  </th>
  <th class="symcomm">&nbsp;Comment&nbsp;
  </th>
  <th class="symdef">&nbsp;Defined&nbsp;<!--
    <img src="sort_down.png" class="click" onclick="listed.symtable_def_sort_down();"
         onmouseover="listed.caption(this,'Sort by line where symbols are defined');">&nbsp;
    <img src="sort_up.png"   class="click" onclick="listed.symtable_def_sort_up();"
         onmouseover="listed.caption(this,'Sort by line where symbols are defined');">-->
*/
